--[[

	PartyCombatGizmo: Shows DPS/TTL and the number of attackers for each party member.
		copyright 2005 by Chester
		(Code for DPS/TTL by LOD)

]]

PCGIZMO_VERSION = 2.0;

PCG_DPS_TIME =	20;
PCG_DPS_UPDATERATE = 1;
PCG_NUMATTACKERS_UPDATERATE = 0.9;
PCG_DOTS_UPDATERATE = (PCG_NUMATTACKERS_UPDATERATE * 2)
PCG_MAX_ATTACKERS = 5;
PCG_ATTACKERTIMEOUT = 6;

PCG_DANGERFLASHIN_TIME = 0.4;
PCG_DANGERFLASHOUT_TIME = 0.8;

function PCG_AddMessage( text )
	PCG_PLAYER = UnitName("player").."|"..GetCVar("realmName");
	PCGSAVE = PCGizmo[PCG_PLAYER];
	if (PCGSAVE.debug) then
		if (text) then
			ChatFrame3:AddMessage(GREEN_FONT_COLOR_CODE..""..text.."");	
		end	
	end
end

function PCG_Main_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("CHAT_MSG_COMBAT_CREATURE_VS_PARTY_HITS");
	this:RegisterEvent("CHAT_MSG_COMBAT_CREATURE_VS_PARTY_MISSES");
	this:RegisterEvent("CHAT_MSG_SPELL_CREATURE_VS_PARTY_DAMAGE");
	this:RegisterEvent("CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS");
	this:RegisterEvent("CHAT_MSG_COMBAT_CREATURE_VS_SELF_MISSES");
	this:RegisterEvent("CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE");

	this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE");
	this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_BUFFS");
	this:RegisterEvent("CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE");
	this:RegisterEvent("CHAT_MSG_SPELL_HOSTILEPLAYER_BUFF");
	this:RegisterEvent("CHAT_MSG_COMBAT_HOSTILEPLAYER_HITS");
	this:RegisterEvent("CHAT_MSG_COMBAT_HOSTILEPLAYER_MISSES");
	this:RegisterEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH");
	this:RegisterEvent("CHAT_MSG_COMBAT_XP_GAIN");
	
	this:RegisterEvent("SPELLCAST_CHANNEL_START");
	this:RegisterEvent("SPELLCAST_START");
	this:RegisterEvent("SPELLCAST_FAILED");
	
	SLASH_PARTYCOMBATGIZMO1 = "/partycombatgizmo";
	SLASH_PARTYCOMBATGIZMO2 = "/pcg";
	SlashCmdList["PARTYCOMBATGIZMO"] = function(msg)
		PCG_SlashCommand(msg);
	end
end

function PCG_DPSFrameTemplate_OnLoad()
  	
	this:RegisterEvent("UNIT_COMBAT");
	this:RegisterEvent("UNIT_HEALTH");
	this:RegisterEvent("UNIT_MAXHEALTH");
		
	local frameName = this:GetName();
	this.dpstext = getglobal( frameName.."_DPSText" );
	this.dpsframe = getglobal( frameName.."_DPS" );
	if (this:GetID() == 6) then
		this.dpstext:SetText("");
		getglobal( frameName.."_DPSTitleText" ):SetText("");
		getglobal( frameName.."_DPSTitleText" ):Hide();
	else
		this.dpstext:SetText("0.0");
	end	

	-- Data
	this.healthevents = {};
	this.prevhealth = nil;
	this.dps = 0;
	this.lastupdate = 0;

end

function PCG_SlashCommand(msg)
		--CSG_TEXT_ENEMYDETECTION_OFF = "|cffffff00CSG: |cffffffffDetecting Enemies is now: |cffff2020-OFF-";
		--CSG_TEXT_ENEMYDETECTION_ON = "|cffffff00CSG: |cffffffffDetecting Enemies is now: |cff20ff20-ON-";
	if( not msg or msg == "" ) then
		DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20PartyCombatGizmo Commands:");
		DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20/pcg toggle |cff3366ff- toggle frames on and off (do this first to position your frames)");
		DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20/pcg player |cff3366ff- toggle visibility of your own PCG frame");
		DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20/pcg target |cff3366ff- toggle visibility of your target's PCG frame");
		DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20/pcg lock |cff3366ff- toggle the frames being locked/clickable");
	end
	if( msg == "toggle" ) then
		if (PCGSAVE.dpsvis and PCGSAVE.dpsvis == 1) then
			DEFAULT_CHAT_FRAME:AddMessage("|cffffff00PCG: |cffffffffNow hiding frames.");
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cffffff00PCG: |cffffffffNow showing frames.");
		end
		PCG_ToggleDPSFrames();
	end
	if( msg == "player" ) then
		if (not PCGSAVE["player"]) then
			PCGSAVE = { ["player"] = {} };
		end
		if (not PCGSAVE["player"].hide or PCGSAVE["player"].hide == 0) then
			PCGSAVE["player"].hide = 1;
			PCG_ToggleDPSFrames();
			PCG_ToggleDPSFrames();
			DEFAULT_CHAT_FRAME:AddMessage("|cffffff00PCG: |cffffffffHiding Player frame.");
		else
			PCGSAVE["player"].hide = 0;
			PCG_ToggleDPSFrames();
			PCG_ToggleDPSFrames();
			DEFAULT_CHAT_FRAME:AddMessage("|cffffff00PCG: |cffffffffShowing Player frame.");
		end
	end

	if( msg == "lock" ) then
		PCG_LockFrames();
	end
end

--/script PCG_AddMessage( PCGSAVE.dpsvis );
function PCG_ToggleDPSFrames()
  	
	if (not PCGizmo) then
		PCGizmo = {
			[PCG_PLAYER] = {},
		};
	end
	if (not PCGizmo[PCG_PLAYER]) then
		PCGizmo[PCG_PLAYER] = {};
	end		
	if (PCGSAVE.dpsvis and PCGSAVE.dpsvis == 1) then
		PCGSAVE.dpsvis = 0;
		getglobal("PCG_PlayerDPS"):Hide();
		getglobal("PCG_PlayerDPSLabel"):Hide();
		getglobal("PCG_PetDPS"):Hide();
		getglobal("PCG_PetDPSLabel"):Hide();
		for i=1, 4, 1 do
			getglobal("PCG_PartyMemberDPS"..i):Hide();
			getglobal("PCG_PartyMemberDPS"..i.."Label"):Hide();
		end
		for i=1, 4, 1 do
			getglobal("PCG_PartyMemberPetDPS"..i):Hide();
			getglobal("PCG_PartyMemberPetDPS"..i.."Label"):Hide();
		end
	else
		PCGSAVE.dpsvis = 1;
		if (not PCGSAVE["player"]) then
			PCGSAVE = { ["player"] = {} };
		end
		if (not PCGSAVE["player"].hide or PCGSAVE["player"].hide == 0) then
			getglobal("PCG_PlayerDPS"):Show();
			getglobal("PCG_PlayerDPSLabel"):Show();
		else
			getglobal("PCG_PlayerDPS"):Hide();
			getglobal("PCG_PlayerDPSLabel"):Hide();
		end
		getglobal("PCG_PetDPS"):Show();
		getglobal("PCG_PetDPSLabel"):Show();
		for i=1, 4, 1 do
			getglobal("PCG_PartyMemberDPS"..i):Show();
			getglobal("PCG_PartyMemberDPS"..i.."Label"):Show();
		end
		for i=1, 4, 1 do
			getglobal("PCG_PartyMemberPetDPS"..i):Show();
			getglobal("PCG_PartyMemberPetDPS"..i.."Label"):Show();
		end
	end
end

function PCG_LockFrames()
	local i;
	if (not PCGSAVE.lock or PCGSAVE.lock == 0) then
		PCGSAVE.lock = 1;
		i = 0;
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00PCG: |cffffffffLocking frames.");
	else
		PCGSAVE.lock = 0;
		i = 1;
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00PCG: |cffffffffUnlocking frames.");
	end
	getglobal("PCG_PlayerDPS"):EnableMouse(i);
	getglobal("PCG_PlayerDPSLabel"):Hide();
	getglobal("PCG_PetDPS"):EnableMouse(i);
	getglobal("PCG_PetDPSLabel"):Hide();
	for i=1, 4, 1 do
		getglobal("PCG_PartyMemberDPS"..i):EnableMouse(i);
		getglobal("PCG_PartyMemberDPS"..i.."Label"):Hide();
	end
	for i=1, 4, 1 do
		getglobal("PCG_PartyMemberPetDPS"..i):EnableMouse(i);
		getglobal("PCG_PartyMemberPetDPS"..i.."Label"):Hide();
	end
end

function PCG_DPSFrameTemplate_OnEvent()
  	  	
	if ( event == "UNIT_COMBAT" or event == "UNIT_HEALTH" or event == "UNIT_MAXHEALTH" ) then
		local unit = "player";
		if ( this:GetID() ~= 0 ) then
			if (this:GetID() == 5) then
				unit = "pet";
			elseif (this:GetID() == 6) then
				if (PCGSAVE.dpsvis and PCGSAVE.dpsvis == 0 and not UnitExists("target")) then
					this:Hide();
					return;	
				end
				unit = "target";
			elseif (this:GetID() < 10) then
				unit = "party"..this:GetID();
			else
				unit = "partypet"..(this:GetID() - 10);
			end
		end
		if ( unit == nil ) then
			return;
		end

		if ( this.prevhealth == nil ) then
			this.prevhealth = UnitHealth(unit);
		end

		if ( arg1 == unit ) then
			local dmg = this.prevhealth - UnitHealth(unit);

			if ( dmg > 0 ) then
				-- 1 is OFF or not visible
				if (not PCGizmo) then
					PCGizmo = {
						[PCG_PLAYER] = {},
					};
				end
				if (not PCGizmo[PCG_PLAYER]) then
					PCGizmo[PCG_PLAYER] = {};
				end
				PCGSAVE = PCGizmo[PCG_PLAYER];

				if (not PCGSAVE[unit] or not PCGSAVE[unit].hide or PCGSAVE[unit].hide == 0) then
					this:Show();
				end
				
				local temp = { };
				temp["time"] = GetTime();
				temp["damage"] = dmg;
				table.insert(this.healthevents, temp);

				--DEFAULT_CHAT_FRAME:AddMessage(dmg.." damage to party member "..UnitName(unit)..", time "..GetTime()..", health "..UnitHealth(unit));

				if (this.dps == nil) then
					this.dps = dmg;
				else
					this.dps = this.dps + dmg;
					--DEFAULT_CHAT_FRAME:AddMessage( UnitName(unit).." dps total: "..this.dps );
				end

			elseif ( dmg < 0 ) then
				--DEFAULT_CHAT_FRAME:AddMessage((dmg*-1).." healing to party member "..UnitName(unit)..", time "..GetTime()..", health "..UnitHealth(unit));
			end
			
			if (unit ~= "target") then
				PCG_Show_DMGNumber( unit, dmg, this );	
			end	

			this.prevhealth = UnitHealth(unit);		
		end
		return;
	end

	if ( event == "PLAYER_REGEN_ENABLED" ) then
		this:Hide();
		return;
	end	
end

function PCG_DPSFrameTemplate_OnUpdate()
	local unit = "player";
	if ( this:GetID() ~= 0 ) then
		if (this:GetID() == 5) then
			unit = "pet";
		elseif (this:GetID() == 6) then
			unit = "target";
		elseif (this:GetID() < 10) then
			unit = "party"..this:GetID();
		else
			unit = "partypet"..(this:GetID() - 10);
		end
	end
	if ( unit == nil ) then
		return;
	end

	--if (this:IsVisible()) then
	--	PCG_AttackerDot_CheckTimer(unit, this:GetID());		
	--end

	if ( this.prevhealth == nil ) then
		this.prevhealth = UnitHealth(unit);
	end

	local curtime = GetTime();
	local oldesttime = 0;
	local deleteindex = 0;
	local glow = getglobal(this:GetName().."_Glow"); 

	if ( (curtime - this.lastupdate) > PCG_DPS_UPDATERATE ) then

		if ( (table.getn(this.healthevents) == 0 ) ) then
			if (not PCGSAVE.dpsvis or PCGSAVE.dpsvis == 0) then
				this:Hide();
			else
				if (unit == "target") then
					this.dpsframe:SetWidth(1);
					if (PCGSAVE.dpsvis and PCGSAVE.dpsvis == 0 and not UnitExists("target")) then
						this:Hide();
					end
				else
					this.dpsframe:SetWidth(this.dpstext:GetStringWidth() + 6);
				end				
			end
			return;
		end

		for i=1, table.getn(this.healthevents), 1 do
			if ( (curtime - PCG_DPS_TIME) > this.healthevents[i].time ) then
				this.dps = this.dps - this.healthevents[i].damage;
				--DEFAULT_CHAT_FRAME:AddMessage( UnitName(unit).." dps total: "..this.dps );
				deleteindex = i;
			else
				oldesttime = this.healthevents[i].time;
				break;
			end
		end

		-- Remove entries from deleteindex down so we don't miss em
		while (deleteindex > 0) do
			--DEFAULT_CHAT_FRAME:AddMessage( curtime.." : Removed event for "..UnitName(unit)..". Damage "..this.healthevents[deleteindex].damage.." at time "..this.healthevents[deleteindex].time );
			table.remove(this.healthevents, deleteindex);
			deleteindex = deleteindex-1;
		end
		if ( this.dps ~= nil ) then
			--DEFAULT_CHAT_FRAME:AddMessage( UnitName(unit).." DPSTOTAL: "..this.dps.." over time "..(curtime - oldesttime+1).." = "..(this.dps / (curtime - oldesttime+1) ) ); 
			local DPS = (this.dps / (curtime - oldesttime+1));
			if ( DPS ) then
				if (unit == "target") then
					this.dpstext:SetText( "" );
				else
					this.dpstext:SetText( format(TEXT("%.1f"), DPS ) );
				end
			else
				if (unit == "target") then
					this.dpstext:SetText( "" );
				else
					this.dpstext:SetText( format(TEXT("0"), DPS ) );
				end
			end
		end

		if (unit == "target") then
			this.dpsframe:SetWidth(1);
		else
			this.dpsframe:SetWidth(this.dpstext:GetStringWidth() + 6);
		end	

		this.lastupdate = curtime;
	end

	if (not this.resetattackers) then
		this.resetattackers = curtime;	
	end
	if (not this.approxattackers) then
		this.approxattackers = 0;	
	end
	if (not this.updatedots) then
		this.updatedots = curtime;	
	end
	if (not PCG or not PCG.Attackers) then
		PCG = { party = {}, partypet = {}, Attackers = { [unit] = 0 } };
		PCG_AddMessage("__!! NOT PCG");
		return;
	end
	if (not PCG.Attackers[unit] or PCG.Attackers[unit] == 0) then
		this.approxattackers = 0;
		return;
	end
	if ( (curtime - this.updatedots) > PCG_DOTS_UPDATERATE ) then
		if (PCG and PCG.Attackers[unit]) then
			PCG_UpdateDots(unit, this);	
		end
		this.updatedots = curtime;
	end
	if ( (curtime - this.resetattackers) > PCG_NUMATTACKERS_UPDATERATE ) then
		this.resetattackers = curtime;
		this.approxattackers = PCG.Attackers[unit];
	end
	--PCG_AddMessage("!!!! approxattackers = "..this.approxattackers);

end

function PCG_Show_DMGNumber( unit, damage, frame )
  	
--	DEFAULT_CHAT_FRAME:AddMessage( "FN amount = "..amount );
	if (damage == 0 ) then
		return;
	end
	damage = (damage * -1);
	local percent = (damage / UnitHealthMax(unit)) * 100;

	--if (damage < 0) then
	--	damage = (damage * -1)
	--end


	if ( frame ) then
		local floatingframe; 
		local floatingframetext;

		for i=1, 20, 1 do
			floatingframe = getglobal(frame:GetName().."FloatingNumber"..i); 
			floatingframetext = getglobal(frame:GetName().."FloatingNumber"..i.."_Text");
			
			-- If the frame is flashing, then it is being used.  Check if the next frame is available.
			if ( not UIFrameIsFlashing(floatingframe) ) then 
				local color = { r = 0, g = 0, b = 0 };
				local height = (percent * 0.4) + 10;
				if (percent < 0) then
					color.r = (((percent*-1) * 0.003) + 0.82);
					if (color.r < 0.85) then
						color.r = 0.85;	
					elseif (color.r > 1) then
						color.r = 1;
					end
					height = (percent * 0.5) + 10;
				elseif (percent > 10) then
					color.g = ((percent * 0.003) + 0.82);	
					if (color.g < 0.85) then
						color.g = 0.85;	
					elseif (color.g > 1) then
						color.g = 1;	
					end
					damage = "+"..damage;
					height = (percent * 0.25) + 10;
				else
					break;
				end
				local time = (percent / 6);
				local x = math.random(-14, 14); 
				if (height < 11) then
					height = 11;	
				elseif (height > 34) then
					height = 34;
				end
				if (time < 2) then
					time = 2;	
				end
				--DEFAULT_CHAT_FRAME:AddMessage( "percent: "..percent.." color: ("..color.r..color.g..color.b..") height: "..height.." time: "..time );

				floatingframetext:SetTextColor(color.r, color.g, color.b);
				floatingframetext:SetText( damage );
				floatingframetext:SetTextHeight( height );

				floatingframe:Show();
				local scale = frame:GetScale();
				frame:SetScale(2);
				frame:SetScale(scale);
				
--				DEFAULT_CHAT_FRAME:AddMessage( "SHOWING NUMBER : "..i );
				PCG_Animate_DMGNumber(floatingframe, x, 0, x, 32, nil, time);	
				UIFrameFlash(floatingframe, 0.1, time, (time + 1), nil, 1, 0.1);
				--(frame, fadeInTime, fadeOutTime, flashDuration, showWhenDone, flashInHoldTime, flashOutHoldTime)
				break;
			end
		end		
	end
end

function PCG_Position_DPSFrames()
	local unit = "player";
	local frame;

	if (PCGSAVE[unit] and PCGSAVE[unit].framepos_L and PCGSAVE[unit].framepos_T) then
		PCG_PlayerDPS:SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT", PCGSAVE[unit].framepos_L, PCGSAVE[unit].framepos_T);			
	end
	unit = "pet";
	if (PCGSAVE[unit] and PCGSAVE[unit].framepos_L and PCGSAVE[unit].framepos_T) then
		PCG_PetDPS:SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT", PCGSAVE[unit].framepos_L, PCGSAVE[unit].framepos_T);			
	end
	for i=1, 4, 1 do
		unit = "party"..i;
		frame = getglobal("PCG_PartyMemberDPS"..i);
		if (PCGSAVE[unit] and PCGSAVE[unit].framepos_L and PCGSAVE[unit].framepos_T) then
			frame:ClearAllPoints();
			frame:SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT", PCGSAVE[unit].framepos_L, PCGSAVE[unit].framepos_T);			
		end
	end
	for i=1, 4, 1 do
		unit = "partypet"..i;
		frame = getglobal("PCG_PartyMemberPetDPS"..i);
		if (PCGSAVE[unit] and PCGSAVE[unit].framepos_L and PCGSAVE[unit].framepos_T) then
			frame:ClearAllPoints();
			frame:SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT", PCGSAVE[unit].framepos_L, PCGSAVE[unit].framepos_T);			
		end
	end

	if (PCGSAVE.dpsvis and PCGSAVE.dpsvis == 1) then
		PCG_ToggleDPSFrames();
	end
end

function PCG_DMGFrame_OnShow()
  	
	local unit = "player";
	if ( this:GetID() ~= 0 ) then
		if (this:GetID() == 5) then
			unit = "pet";
			this:SetScale(2);
			this:SetScale(UIParent:GetScale() * 0.9);
		elseif (this:GetID() == 6) then
			unit = "target";
		elseif (this:GetID() < 10) then
			unit = "party"..this:GetID();
		else
			unit = "partypet"..(this:GetID() - 10);
			this:SetScale(2);
			this:SetScale(UIParent:GetScale() * 0.8);
		end
		PCG_AddMessage("!!!! setting scales for: "..unit);
	end
	if (not PCGizmo) then
		PCG_PLAYER = UnitName("player").."|"..GetCVar("realmName");
		PCGizmo = {
			[PCG_PLAYER] = {},
		};
	end
	if (not PCGizmo[PCG_PLAYER]) then
		PCGizmo[PCG_PLAYER] = {};
	end
	if (PCGizmo[PCG_PLAYER][unit] and PCGizmo[PCG_PLAYER][unit].framepos_L and PCGizmo[PCG_PLAYER][unit].framepos_T) then
		return;		
	end
	local id = this:GetID();
	local DUF;
	this:ClearAllPoints();
	if (id == 0) then
		DUF = getglobal("DUF_PlayerFrame");
		if (DUF) then
			this:SetPoint("LEFT", "DUF_PlayerFrame", "RIGHT", 64, 0);
		else
			this:SetPoint("LEFT", "PlayerFrame", "RIGHT", -2, 0);
		end
		--this:SetPoint("CENTER", "UIParent", "CENTER", 32, 0);
	elseif (id == 5) then
		DUF = getglobal("DUF_PetFrame");
		if (DUF) then
			this:SetPoint("LEFT", "DUF_PetFrame", "RIGHT", 64, 0);
		else
			this:SetPoint("LEFT", "PetFrame", "RIGHT", -2, 0);
		end
	elseif (id == 6) then

	elseif (id < 10) then
		DUF = getglobal("DUF_PartyFrame"..id);
		if (DUF) then
			this:SetPoint("LEFT", "DUF_PartyFrame"..id, "RIGHT", 64, 0);
		else
			this:SetPoint("LEFT", "PartyMemberFrame"..id, "RIGHT", 64, 0);
		end
	else
		DUF = getglobal("DUF_PartyPetFrame"..(id-10));
		if (DUF) then
			this:SetPoint("LEFT", "DUF_PartyPetFrame"..(id-10), "RIGHT", 64, 0);
		else
			this:SetPoint("LEFT", "PartyMemberFrame"..(id-10).."PetFrame", "RIGHT", 64, 0);
		end
	end
end

--------------------------------------------------------------------------------------------------------------------------------------
-- NUMBER MOVEMENT
--------------------------------------------------------------------------------------------------------------------------------------
-- Move a floating number from x1,y1 to x2,y2.
function PCG_Animate_DMGNumber( frame, x1,y1, x2,y2, func, duration )
	--CD_CurAnimations = CD_CurAnimations + 1;

	-- Move to the start point
	frame:ClearAllPoints();
	frame:SetPoint("CENTER", frame:GetParent():GetName(), "CENTER", x1, y1 );

	frame.moving = 1;
	frame.startxpos = x1;
	frame.startypos = y1;
	frame.targetxpos = x2;
	frame.targetypos = y2;
	frame.animfunc_move = func;
	frame.startTime = GetTime();
	frame.endTime = frame.startTime + (duration);
end

-- An animation has just finished
function PCG_Animate_DMGNumber_Finished()
	--CD_CurAnimations = CD_CurAnimations - 1;

	this.moving = nil;
	--this.animfunc_move();

	-- Hide ourselves and move back to our original position
	this:ClearAllPoints();
	this:SetPoint("CENTER", this:GetParent():GetName(), "CENTER", this.startxpos, this.startypos);
	this:Hide();
end


function PCG_ShowDMGNumber_OnUpdate()
	if ( this.moving ) then
		this:ClearAllPoints();

		local fraction = (GetTime() - this.startTime) / (this.endTime - this.startTime);
		if ( fraction >= 1.0 ) then
			PCG_Animate_DMGNumber_Finished();
		else
			local xpos = this.startxpos + (fraction * (this.targetxpos - this.startxpos));
			local ypos = this.startypos + (fraction * (this.targetypos - this.startypos));
			this:SetPoint("CENTER", this:GetParent():GetName(), "TOP", xpos, ypos);
		end
	end
--[[
	if ( this.fadingout ) then
		if ( this:GetAlpha() <= this.targetalpha ) then
			CD_Animate_FadeOut_Finished();
		end
	elseif ( this.fadingin ) then
		if ( this:GetAlpha() >= this.targetalpha ) then
			CD_Animate_FadeIn_Finished();
		end
	end]]
end

-- this function is called when the frame should be dragged around
function PCG_DMGFrame_OnMouseDown(arg1)
	if (arg1 == "LeftButton") then
		this:StartMoving();
		getglobal(this:GetName().."Label"):Show();
	end
end

-- this function is called when the frame is stopped being dragged around
function PCG_DMGFrame_OnMouseUp(arg1)
	if (arg1 == "LeftButton") then
		this:StopMovingOrSizing();
		
		local unit = "player";
		if ( this:GetID() ~= 0 ) then
			if (this:GetID() == 5) then
				unit = "pet";
			elseif (this:GetID() == 6) then

			elseif (this:GetID() < 10) then
				unit = "party"..this:GetID();
			else
				unit = "partypet"..(this:GetID() - 10);
			end
		end		

		-- save the position 
		if (not PCGSAVE[unit]) then
			PCGSAVE[unit] = {};	
		end
		PCGSAVE[unit].framepos_L = this:GetLeft();
		PCGSAVE[unit].framepos_T = this:GetTop();

		if (not PCGizmo[PCG_PLAYER].dpsvis or PCGizmo[PCG_PLAYER].dpsvis == 0) then
			getglobal(this:GetName().."Label"):Hide();	
		else
			getglobal(this:GetName().."Label"):Show();
		end
	end

	-- If Rightclick bring up the options menu
--[[	if ( arg1 == "RightButton" ) then
		ToggleDropDownMenu(1, TipBuddy_SavedVars["general"]["anchor_pos"], TipBuddy_Header_FrameDropDown, this:GetName(), 0, 0);
		UIDropDownMenu_SetSelectedValue(this, TipBuddy_SavedVars["general"]["anchor_pos"]);
		return;
	end
	-- Close all dropdowns
	CloseDropDownMenus();]]
end

function PCG_CaptureAttack(unitName, targetName, damage, skipcheck)
	if (CSGiz.dps == 0) then
    	return;
  	end
  	if (SizeUpGizmoConfig.dps == false) then
    	return;
  	end
  	
	if (not PCG) then
		PCG = { party = {}, partypet = {}, Attackers = {} };	
		PCG_AddMessage("__!! PCG doesnt exist");
	end
	for i=1, GetNumPartyMembers(), 1 do
		PCG.party[i] = UnitName("party"..i);
		PCG.partypet[i] = UnitName("partypet"..i);
	end

	if (not skipcheck) then
		--checks to make sure this isnt a party member or a friendly ('skipcheck' skips this)
		for i=1, GetNumPartyMembers(), 1 do
			if (unitName == PCG.party[i]) then
				return;
			end
		end
	end

	local partyname, unit, id, frame;
	if (targetName and targetName == UnitName("pet")) then
		--partyname = targetName;
		unit = "pet";
		id = 5;
	end
	for i=1, GetNumPartyMembers(), 1 do
		if (targetName and targetName == PCG.party[i]) then
			--partyname = targetName;
			unit = "party"..i;
			id = i;
		end
	end
	for i=1, GetNumPartyMembers(), 1 do
		if (targetName and targetName == PCG.partypet[i]) then
			--partyname = targetName;
			unit = "partypet"..i;
			id = i;
		end
	end
	if (not unit) then
		return;	
	end
	if (not PCG[unit]) then
		PCG[unit] = {};	
	end

	if (id == 0 or id == 6) then
		return;
	elseif (id == 5) then
		frame = getglobal("PCG_PetDPS");
	elseif (id < 10) then
		frame = getglobal("PCG_PartyMemberDPS"..id);
	else
		frame = getglobal("PCG_PartyMemberPetDPS"..(id-10));
	end

	if (PCGSAVE.debug == 1) then
		local dam_debug = damage;
		local targ_debug = targetName;
		if (not targ_debug) then targ_debug = "unknown";	end
		if (not dam_debug) then dam_debug = "0";	end
		PCG_AddMessage("!!!- captured: "..dam_debug.." damage for "..unitName.." against "..targ_debug);
	end
	local found, occupied, slot;
	local num = 0;
	if (not PCG.Attackers[unit] or PCG.Attackers[unit] == 0) then
		PCG[unit][1] = {name = unitName, dam = tonumber(damage), time = GetTime(), rate = 0, attacks = 1};
		--PCG_ShowNewDot(1, unit, frame);
		PCG.Attackers[unit] = 1;
		PCG_ShowNewAttacker(unit, frame, targetName, 1, first);
		PCG_AddMessage("NEW ATTACKER! - slot "..PCG.Attackers[unit]);
	elseif (PCG.Attackers[unit] == PCG_MAX_ATTACKERS) then
		PCG_AddMessage("__REACHED MAX ATTACKERS");
		return;
	else
		--see if the name exists on our list
		for i=1, PCG_MAX_ATTACKERS, 1 do
			if (PCG[unit][i]) then
				num = num + 1;
				occupied = i;
				PCG_AddMessage("!!!- slot "..i.." occupied by "..PCG[unit][i].name);
				if (unitName == PCG[unit][i].name) then
					if (PCG[unit][i].rate == 0) then
						PCG[unit][i].rate = (GetTime() - PCG[unit][i].time);
						PCG[unit][i].attacks = PCG[unit][i].attacks + 1;
					elseif (PCG[unit][i].attacks <= 6) then
						PCG[unit][i].rate = ((GetTime() - PCG[unit][i].time) + PCG[unit][i].rate) / 2;
						PCG[unit][i].attacks = PCG[unit][i].attacks + 1;
					end
					PCG_AddMessage("cur rate: "..PCG[unit][i].rate.."  new rate: "..(GetTime() - PCG[unit][i].time));
					PCG_AddMessage("!!!- slot "..i.." matches attacker name: "..unitName);
					--PCG_AttackerDot_OnShow(i, unit, frame);
					PCG_ShowNewAttacker(unit, frame, targetName, i);
					PCG[unit][i].time = GetTime();
					--PCG_UpdateDots(unit, frame);
					found = 1;
					break;
				end
			end
			if (num >= PCG.Attackers[unit]) then
				break;	
			end
	--	PCG_AddMessage(i);
		end
		num = 0;
		if (not found) then
			--if no visible frames or we've hit our max, then insert into the first blank one we find
			if (occupied) then
				--name wasn't found, but there are visible frames so insert the new frame after the last visible
				PCG[unit][(occupied + 1)] = {name = unitName, dam = tonumber(damage), time = GetTime(), rate = 0, attacks = 1};
				--PCG_ShowNewDot((occupied + 1), unit, frame);
				if (not PCG.Attackers[unit]) then
					PCG.Attackers[unit] = 1;
				else
					PCG.Attackers[unit] = PCG.Attackers[unit] + 1;
				end
				PCG_ShowNewAttacker(unit, frame, targetName, (occupied + 1), first);

			elseif (occupied == PCG_MAX_ATTACKERS or occupied == nil) then
				for i=1, PCG_MAX_ATTACKERS, 1 do
					if (not PCG[unit][i]) then
						PCG[unit][i] = {name = unitName, dam = tonumber(damage), time = GetTime(), rate = 0, attacks = 1};
						--PCG_ShowNewDot(i, unit, frame);
						if (not PCG.Attackers[unit]) then
							PCG.Attackers[unit] = 1;
						else
							PCG.Attackers[unit] = PCG.Attackers[unit] + 1;
						end
						PCG_ShowNewAttacker(unit, frame, targetName, i, first);
						break;
					end
				end			
			end
		end
	end
	--PCG_AddMessage("!!!! Damagers = "..PCG.Attackers[unit]);
end


function PCG_ShowNewAttacker(unit, frame, targetName, id, first)
	if (targetName ~= UnitName(unit)) then
		return;	
	end
	if (not first) then
		if (not id or ((GetTime() - PCG[unit][id].time) + ((GetTime() - PCG[unit][id].time) * 0.2)) >= PCG[unit][id].rate) then
			return;
		end
	end
	if (not frame.resetattackers) then
		frame.resetattackers = GetTime();	
	end
	if (not PCG or not PCG.Attackers) then
		PCG = { party = {}, partypet = {}, Attackers = { [unit] = 1 } };
		PCG_AddMessage("__NOT PCG");
	end
	if (not frame.approxattackers or frame.approxattackers == 0) then
		frame.approxattackers = PCG.Attackers[unit];	
	elseif (PCG.Attackers[unit] ~= 0) then
		frame.approxattackers = frame.approxattackers + 1;
		if (frame.approxattackers < PCG.Attackers[unit]) then
			frame.approxattackers = PCG.Attackers[unit];	
		end		
	end
	PCG_UpdateDots(unit, frame);
end

function PCG_UpdateDots(unit, frame)
	if (not frame.curvisibledots) then
		frame.curvisibledots = 0;	
	end
	local dot, numdots;
	local dotframe = getglobal(frame:GetName().."DotFrame");
	dotframe:Hide();
	for i=1, 5, 1 do
		dot = getglobal(frame:GetName().."DotFrame_AttackerDot"..i);
		dot:Hide();
	end
	if (not frame.approxattackers) then
		frame.approxattackers = PCG.Attackers[unit];
	elseif (not PCG.Attackers[unit] or PCG.Attackers[unit] == 0) then
		frame.approxattackers = 0;
	end
	for i=1, frame.approxattackers, 1 do
		if (i > 5) then
			break;	
		end
		dotframe:Show();
		dot = getglobal(frame:GetName().."DotFrame_AttackerDot"..i);
		if (i > frame.curvisibledots) then
			PCG_ShowNewDot(i, unit, frame)
		else
			dot:Show();			
		end
		numdots = i;
	end
	frame.curvisibledots = numdots;
	PCG_AddMessage("!approxattackers = "..frame.approxattackers.." Time = "..GetTime());
end

function PCG_ShowNewDot(slot, unit, frame)
	
--	if (PCG.Attackers[unit] == 0) then
--		PlaySoundFile("Sound\\Interface\\TalentScreenOpen.wav");
--	else
--		PlaySoundFile("Sound\\Interface\\MouseOverTarget.wav");
--	end

	attackerDotHighlight = getglobal(frame:GetName().."DotFrame_AttackerDot"..slot.."Highlight");
	attackerDotShine = getglobal(frame:GetName().."DotFrame_AttackerDot"..slot.."Shine");

	--PCG_AttackerDot_OnShow(slot, unit, frame);
	UIFrameFlash(attackerDotShine, 0.2, 5, 5.7, nil, 0.5, 0.1);

				--UIFrameFlash(floatingframe, 0.1, time, (time + 1), nil, 1, 0.1);
				--(frame, fadeInTime, fadeOutTime, flashDuration, showWhenDone, flashInHoldTime, flashOutHoldTime)
end

function PCG_AttackerDot_OnShow(slot, unit, frame)

	local dotframe = getglobal(frame:GetName().."DotFrame");
	local dot = getglobal(frame:GetName().."DotFrame_AttackerDot"..slot);

	dotframe:Show();
	PCG[unit][(PCG.Attackers[unit])].startTime = GetTime();
	PCG[unit][(PCG.Attackers[unit])].endTime = PCG[unit][(PCG.Attackers[unit])].startTime + PCG_ATTACKERTIMEOUT;
	dot:Show();
end

--MAY NOT USE
function PCG_AttackerDot_CheckTimer(unit, id)
	local frame;
	if (id == 0) then
		return;
	elseif (id < 10) then
		frame = getglobal("PCG_PartyMemberDPS"..id);
	else
		frame = getglobal("PCG_PartyMemberPetDPS"..(id-10));
	end
	if (not PCG or not PCG.Attackers or not PCG.Attackers[unit] or not PCG[unit][(PCG.Attackers[unit])] or not PCG[unit][(PCG.Attackers[unit])].startTime) then
		return;	
	end
	local dot = getglobal(frame:GetName().."DotFrame_AttackerDot"..PCG.Attackers[unit]);
	local fraction = (GetTime() - PCG[unit][(PCG.Attackers[unit])].startTime) / (PCG[unit][(PCG.Attackers[unit])].endTime - PCG[unit][(PCG.Attackers[unit])].startTime);
	if ( fraction >= 1.0 ) then
		PCG[unit][(PCG.Attackers[unit])] = nil;
		dot:Hide();
		PCG.Attackers[unit] = PCG.Attackers[unit] - 1;
		PCG_AddMessage("__!! REMOVING ATTACKER");
		PCG_UpdateDots(unit, frame);
		return;
	end
end

function PCG_DangerFlashIn( frame )
	frame.flashIn = 1;
	frame.startTime = GetTime();
	frame.endTime = frame.startTime + PCG_DANGERFLASHIN_TIME;
end

function PCG_DangerFlashOut( frame )
	frame.flashIn = 0;
	frame.startTime = GetTime();
	frame.endTime = frame.startTime + PCG_DANGERFLASHOUT_TIME;
end

function PCG_DangerFlash_OnUpdate()
	if (this.isFlashing) then
		local fraction = (GetTime() - this.startTime) / (this.endTime - this.startTime);
		if (this.flashIn == 1) then
			if ( fraction >= 1.0 ) then
				PCG_DangerFlashOut( this );
			else
				local alpha = fraction * 0.5;
				this:SetAlpha(alpha);
			end			
		else
			if ( fraction >= 1.0 ) then
				PCG_DangerFlashIn( this );
			else
				local alpha = (1 + (fraction * -1)) * 0.5;
				this:SetAlpha(alpha);
			end			
		end
		return;
	end
end


function PCG_UnitDeath( unitName )
	local unit, dot, frame;
	unit = "pet";
	if (PCG and PCG.Attackers[unit] and PCG.Attackers[unit] ~= 0) then
		for i=1, 5, 1 do
			dot = getglobal("PCG_PetDPSDotFrame_AttackerDot"..(PCG.Attackers[unit]));
			frame = getglobal("PCG_PetDPS");
			if (PCG[unit] and PCG[unit][i] and PCG[unit][i].name == unitName) then
				PCG_ClearAttacker(unit, frame, i);
			end
		end	
	end
	for i=1, 4, 1 do
		unit = "party"..i;
		if (not PCG or not PCG.Attackers[unit] or PCG.Attackers[unit] == 0) then
			break;	
		end
		for j=1, 5, 1 do
			dot = getglobal("PCG_PartyMemberDPS"..i.."DotFrame_AttackerDot"..(PCG.Attackers[unit]));
			frame = getglobal("PCG_PartyMemberDPS"..i);
			if (PCG[unit] and PCG[unit][j] and PCG[unit][j].name == unitName) then
				PCG_ClearAttacker(unit, frame, j);
			end
		end
	end
	for i=1, 4, 1 do
		unit = "partypet"..i;
		if (not PCG or not PCG.Attackers[unit] or PCG.Attackers[unit] == 0) then
			break;	
		end
		for j=1, 5, 1 do
			dot = getglobal("PCG_PartyMemberPetDPS"..i.."DotFrame_AttackerDot"..(PCG.Attackers[unit]));
			frame = getglobal("PCG_PartyMemberPetDPS"..i);
			if (PCG[unit] and PCG[unit][j] and PCG[unit][j].name == unitName) then
				PCG_ClearAttacker(unit, frame, j);
			end
		end
	end
end

function PCG_ClearAttacker(unit, frame, slot)
	PCG[unit][slot] = nil;
	PCG.Attackers[unit] = PCG.Attackers[unit] - 1;
	if (frame.approxattackers and frame.approxattackers > 0) then
		frame.approxattackers = frame.approxattackers - 1;	
	end		
	PCG_AddMessage("__--REMOVING ATTACKER");
	PCG_UpdateDots(unit, frame);
end

--/script DEFAULT_CHAT_FRAME:AddMessage(PCG_PLAYER)
function PCG_Main_OnEvent(event, arg1)
 	
	--if (event and arg1) then
	--	PCG_AddMessage("event: "..event.."  arg1: "..arg1);		
	--end
	if( event == "VARIABLES_LOADED" ) then
		PCG_PLAYER = UnitName("player").."|"..GetCVar("realmName");
		if (not PCGizmo) then
			PCG_PLAYER = UnitName("player").."|"..GetCVar("realmName");
			PCGizmo = {
				[PCG_PLAYER] = {},
			};
		end
		if (not PCGizmo[PCG_PLAYER]) then
			PCGizmo[PCG_PLAYER] = {};
		end
		PCGSAVE = PCGizmo[PCG_PLAYER];
		
		PCG_Position_DPSFrames();

		if( DEFAULT_CHAT_FRAME ) then
			DEFAULT_CHAT_FRAME:AddMessage("|cff3366ffPartyCombatGizmo v"..PCGIZMO_VERSION.." Loaded |cff20ff20(/pcg for options)");
		end
		return;
	end
	------
	-- Begin processing chat events
	------
	local unitName, targetName, spell, damage;

--	if (event == "CHAT_MSG_COMBAT_SELF_HITS") then
--			PCG_CaptureAttack(UnitName("player"), nil, 0);
--			return;
--	end
--
--	if (event == "CHAT_MSG_SPELL_SELF_BUFF") then
--			PCG_CaptureHealer(UnitName("player"), UnitName("player"), 1);
--			return;
--	end

	if (CSGiz.dps == 0) then
    	return;
  	end
  	if (SizeUpGizmoConfig.dps == false) then
    	return;
  	end
  	
	if (event == "SPELLCAST_CHANNEL_START" or event == "SPELLCAST_START" or event == "SPELLCAST_FAILED") then
		PCG_CaptureAttack(unitName);
		return;
		
	elseif (event == "CHAT_MSG_COMBAT_HOSTILEPLAYER_HITS"
	--or event == "CHAT_MSG_COMBAT_FRIENDLYPLAYER_HITS"
	) then
		PCG_AddMessage(PCG_GRY_TXT.."SPELL - HOSTILE PLAYER_HITS");

		for unitName, targetName, damage in string.gmatch(arg1, PCG_DAM_HIT) do
			PCG_CaptureAttack(unitName, targetName, damage);
			return;
		end
		for unitName, targetName, damage in string.gmatch(arg1, PCG_DAM_CRIT) do
			PCG_CaptureAttack(unitName, targetName, damage);
			return;
		end

	elseif (event == "CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE"
	--or event == "CHAT_MSG_SPELL_FRIENDLYPLAYER_DAMAGE"
	) then
	PCG_AddMessage(PCG_GRY_TXT.."SPELL - HOSTILE PLAYER_DAMAGE");

		if (GetLocale() == "enUS") then
			-- 1 3 2 for german
			for unitName, spell, targetName, damage in string.gmatch(arg1, PCG_SDAM_HIT) do
				PCG_CaptureAttack(unitName, targetName, damage);
				return;
			end
			-- 1 and 2 switched for german
			for unitName, spell, targetName in string.gmatch(arg1, PCG_SDAM_DODGEBY) do
				PCG_CaptureAttack(unitName, targetName);
				return;
			end
			-- 1 and 2 switched for german
			for unitName, spell, targetName in string.gmatch(arg1, PCG_SDAM_EVADEBY) do
				PCG_CaptureAttack(unitName, targetName);
				return;
			end
		elseif (GetLocale() == "deDE") then
			for unitName, targetName, spell, damage in string.gmatch(arg1, PCG_SDAM_HIT) do
				PCG_CaptureAttack(unitName, targetName, damage);
				return;
			end
			-- 1 and 2 switched for german
			for spell, unitName, targetName in string.gmatch(arg1, PCG_SDAM_DODGEBY) do
				PCG_CaptureAttack(unitName, targetName);
				return;
			end
			-- 1 and 2 switched for german
			for spell, unitName, targetName in string.gmatch(arg1, PCG_SDAM_EVADEBY) do
				PCG_CaptureAttack(unitName, targetName);
				return;
			end
		end
		for unitName, spell, targetName, damage in string.gmatch(arg1, PCG_SDAM_CRIT) do
			PCG_CaptureAttack(unitName, targetName, damage);
			return;
		end
	     
		for unitName, spell in string.gmatch(arg1, PCG_SDAM_BLOCK) do
			PCG_CaptureAttack(unitName);
			return;
		end
		for unitName, spell, targetName in string.gmatch(arg1, PCG_SDAM_BLOCKBY) do
			PCG_CaptureAttack(unitName, targetName);
			return;
		end
		for unitName, spell in string.gmatch(arg1, PCG_SDAM_DEFLECT) do
			PCG_CaptureAttack(unitName);
			return;
		end
		for unitName, spell, targetName in string.gmatch(arg1, PCG_SDAM_DEFLECTBY) do
			PCG_CaptureAttack(unitName, targetName);
			return;
		end
		for unitName, spell in string.gmatch(arg1, PCG_SDAM_DODGE) do
			PCG_CaptureAttack(unitName);
			return;
		end

		for unitName, spell in string.gmatch(arg1, PCG_SDAM_EVADE) do
			PCG_CaptureAttack(unitName);
			return;
		end

		for unitName, spell in string.gmatch(arg1, PCG_SDAM_FAIL) do
			PCG_CaptureAttack(unitName);
			return;
		end
		for unitName, spell in string.gmatch(arg1, PCG_SDAM_MISS) do
			PCG_CaptureAttack(unitName);
			return;
		end
		for unitName, spell in string.gmatch(arg1, PCG_SDAM_PARRY) do
			PCG_CaptureAttack(unitName);
			return;
		end
		for unitName, spell in string.gmatch(arg1, PCG_SDAM_RESIST) do
			PCG_CaptureAttack(unitName);
			return;
		end
		for unitName, spell, targetName in string.gmatch(arg1, PCG_SDAM_RESISTBY) do
			PCG_CaptureAttack(unitName, targetName);
			return;
		end

	elseif (event == "CHAT_MSG_COMBAT_HOSTILEPLAYER_MISSES") then
--	PCG_AddMessage("CREATURE_VS_SELF_MISSES");
		PCG_AddMessage(PCG_GRY_TXT.."COMBAT - HOSTILE PLAYER_MISSES");

		for unitName, targetName in string.gmatch(arg1, PCG_MISS_MISS) do
			PCG_CaptureAttack(unitName, targetName);
			return;
		end
		for unitName, targetName in string.gmatch(arg1, PCG_MISS_PARRY) do
			PCG_CaptureAttack(unitName, targetName);
			return;
		end
		for unitName, targetName in string.gmatch(arg1, PCG_MISS_EVADE) do
			PCG_CaptureAttack(unitName, targetName);
			return;
		end
		for unitName, targetName in string.gmatch(arg1, PCG_MISS_DODGE) do
			PCG_CaptureAttack(unitName, targetName);
			return;
		end
		for unitName, targetName in string.gmatch(arg1, PCG_MISS_DEFLECT) do
			PCG_CaptureAttack(unitName, targetName);
			return;
		end
		for unitName, targetName in string.gmatch(arg1, PCG_MISS_BLOCK) do
			PCG_CaptureAttack(unitName, targetName);
			return;
		end
		for unitName, targetName, damage in string.gmatch(arg1, PCG_MISS_ABSORB) do
			PCG_CaptureAttack(unitName, targetName, damage);
			return;
		end

	-- CREATURES
	elseif (event == "CHAT_MSG_COMBAT_CREATURE_VS_PARTY_HITS" or event == "CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS") then
		--PCG_AddMessage("PARTY - CREATURE_DAMAGE");
		for unitName, targetName, damage in string.gmatch(arg1, PCG_DAM_HIT) do
			PCG_CaptureAttack(unitName, targetName, damage);
			return;
		end
		for unitName, targetName, damage in string.gmatch(arg1, PCG_DAM_CRIT) do
			PCG_CaptureAttack(unitName, targetName, damage);
			return;
		end


	elseif (event == "CHAT_MSG_SPELL_CREATURE_VS_PARTY_DAMAGE"
	or event == "CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE"
	) then
	--PCG_AddMessage("SPELL - CREATURE_DAMAGE");

		for unitName, spell, targetName, damage in string.gmatch(arg1, PCG_SDAM_HIT) do
			PCG_CaptureAttack(unitName, targetName, damage);
			return;
		end
		
		for unitName, spell, targetName, damage in string.gmatch(arg1, PCG_SDAM_CRIT) do
			PCG_CaptureAttack(unitName, targetName, damage);
			return;
		end
	     
		for unitName, spell in string.gmatch(arg1, PCG_SDAM_BLOCK) do
			PCG_CaptureAttack(unitName);
			return;
		end
		for unitName, spell in string.gmatch(arg1, PCG_SDAM_DEFLECT) do
			PCG_CaptureAttack(unitName);
			return;
		end
		for unitName, spell in string.gmatch(arg1, PCG_SDAM_DODGE) do
			PCG_CaptureAttack(unitName);
			return;
		end
		for unitName, spell in string.gmatch(arg1, PCG_SDAM_EVADE) do
			PCG_CaptureAttack(unitName);
			return;
		end
		for unitName, spell in string.gmatch(arg1, PCG_SDAM_FAIL) do
			PCG_CaptureAttack(unitName);
			return;
		end
		for unitName, spell in string.gmatch(arg1, PCG_SDAM_MISS) do
			PCG_CaptureAttack(unitName);
			return;
		end
		for unitName, spell in string.gmatch(arg1, PCG_SDAM_PARRY) do
			PCG_CaptureAttack(unitName);
			return;
		end
		for unitName, spell in string.gmatch(arg1, PCG_SDAM_RESIST) do
			PCG_CaptureAttack(unitName);
			return;
		end


	elseif (event == "CHAT_MSG_COMBAT_CREATURE_VS_PARTY_MISSES" or event == "CHAT_MSG_COMBAT_CREATURE_VS_SELF_MISSES") then
--	PCG_AddMessage("CREATURE_VS_SELF_MISSES");
		for unitName, targetName in string.gmatch(arg1, PCG_MISS_MISS) do
			PCG_CaptureAttack(unitName, targetName);
			return;
		end
		for unitName, targetName in string.gmatch(arg1, PCG_MISS_PARRY) do
			PCG_CaptureAttack(unitName, targetName);
			return;
		end
		for unitName, targetName in string.gmatch(arg1, PCG_MISS_EVADE) do
			PCG_CaptureAttack(unitName, targetName);
			return;
		end
		for unitName, targetName in string.gmatch(arg1, PCG_MISS_DODGE) do
			PCG_CaptureAttack(unitName, targetName);
			return;
		end
		for unitName, targetName in string.gmatch(arg1, PCG_MISS_DEFLECT) do
			PCG_CaptureAttack(unitName, targetName);
			return;
		end
		for unitName, targetName in string.gmatch(arg1, PCG_MISS_BLOCK) do
			PCG_CaptureAttack(unitName, targetName);
			return;
		end
		for unitName, targetName, damage in string.gmatch(arg1, PCG_MISS_ABSORB) do
			PCG_CaptureAttack(unitName, targetName, damage);
			return;
		end
		-- Events below here are used to detect healers and buffers
	
	-- Monster death
	elseif (event == "CHAT_MSG_COMBAT_HOSTILE_DEATH" or event == "CHAT_MSG_COMBAT_XP_GAIN") then
		for unitName in string.gmatch(arg1, PCG_DIES) do 
			PCG_UnitDeath( unitName );
			return;
		end	
		for unitName in string.gmatch(arg1, PCG_SLAINBY) do 
			PCG_UnitDeath( unitName );
			return;
		end
	end
end